/* eslint-disable no-prototype-builtins */
import Graph from 'graphology';
import { Providers, LayoutAlgorithm } from './types';

/**
 * This is our Product
 */

export abstract class Layout<provider extends Providers> {
  constructor(public provider: provider, public algorithm: LayoutAlgorithm<provider>) {
    // console.info(`Created the following Layout: ${provider} - ${this.algorithm}`);
  }

  public layout(graph: Graph, verbose?: boolean) {
    // console.log(`${this.provider} [${this.algorithm}] layouting now`);

    graph.forEachNode((node) => {
      const attr = graph.getNodeAttributes(node);
      if (!attr.hasOwnProperty('x')) {
        graph.setNodeAttribute(node, 'x', Math.random());
      }
      if (!attr.hasOwnProperty('y')) {
        graph.setNodeAttribute(node, 'y', Math.random());
      }
    });
  }
}
